// PointSprite.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_POINTS
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLE_STRIP
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=4

#version 130
#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

uniform float aspectAngleFactor; 

in vec3 positionIn[1];
in float pointSizeIn[1];
out vec3 position;

void main(void){
    gl_Position = gl_PositionIn[0];

    vec4 offset[4] = vec4[]
	(vec4(-1, -1, 0,0), vec4(1, -1, 0,0), vec4(-1, 1, 0,0), vec4(1, 1, 0,0));
    vec4 texCoord[4] = vec4[]
	(vec4(0,0,0,0), vec4(1,0,0,0), vec4(0,1,0,0), vec4(1,1,0, 0)); 
    
    float psize = pointSizeIn[0] * aspectAngleFactor;

    for(int i = 0; i < gl_VerticesIn; i++){
	gl_FrontColor = gl_FrontColorIn[i];
	gl_TexCoord[0] = texCoord[0];
	gl_Position = gl_PositionIn[i] + offset[0] * psize;
	EmitVertex();
	gl_TexCoord[0] = texCoord[1];
	gl_Position = gl_PositionIn[i] + offset[1] * psize;
	EmitVertex();
	gl_TexCoord[0] = texCoord[2];
	gl_Position = gl_PositionIn[i] + offset[2] * psize;
	EmitVertex();
	gl_TexCoord[0] = texCoord[3];
	gl_Position = gl_PositionIn[i] + offset[3] * psize;
	EmitVertex();
    }
    
    EndPrimitive();
}
